const Mysql = require('mysql2/promise');
const shell = require('shelljs');
const fs = require('fs');
const recursive = require('recursive-readdir');
const config = require('config');


const fixedEncodeURIComponent = (str) => {
  return encodeURIComponent(str).replace(/[!'()*]/g, function(c) {
    return '%' + c.charCodeAt(0).toString(16);
  });
}


const shellexec = async (command) => {
  // console.log(command);
  return new Promise((resolve, reject) => {
    shell.exec(command, { async: true }, function (code, stdout, stderr) {
      if (stderr && code !== 0) {
        console.log(stderr);
        console.log(stdout);
        reject({ success: false, code: code, result: stderr });
      }

      if (code === 2) {
        console.log(stderr);
        console.log(stdout);
        reject({ success: false, code: code, result: stdout });
      }
      resolve({ success: true, code: code, result: stdout });
    });
  });
};

const deleteUnusedFile = async () => {
  try {
    const regexTest = /\.(zip|obb|x?apks?)$/;
    const dir = config.get('dir');
    const archiveDir = config.get('archiveDir');
    const mysql = await Mysql.createConnection(config.get('maindb'));

    if (!fs.existsSync(archiveDir)) {
      const createDir = await shellexec(`mkdir -p ${archiveDir}`);
    }

    recursive(dir, async function (err, files) {
      for (taptin of files) {
        if (regexTest.test(taptin)) {
          const fileToCheck = taptin.substr(taptin.lastIndexOf('/') + 1);
          const fileToCheckEscape = fixedEncodeURIComponent(fileToCheck);
          const finalArchiveDir =
            archiveDir + taptin.replace(dir, '').replace(fileToCheck, '');

          if (!fs.existsSync(finalArchiveDir)) {
            const createDir = await shellexec(`mkdir -p ${finalArchiveDir}`);
          }
          const [checkFileExist] = await mysql.query(
            `select * from \`wp_posts\` where \`post_content\` like ?`,
            [`%${fileToCheckEscape}%`]
          );
          if (checkFileExist.length === 0) {
  console.log(taptin, fileToCheck);
	         console.log(`moving ${taptin} (${fileToCheckEscape}) to ${finalArchiveDir}`);
                console.log(' ');
            const moveFile = shell.exec(
              `mv '${taptin}' ${finalArchiveDir}`,
              { async: false },
              function (code, stdout, stderr) {
              }
            );
          }
        }
      }
      mysql.end();
      console.log('done');
      process.exit(0);
    });
  } catch (e) {
    console.log(e);
  }
};

const main = async () => {
  await deleteUnusedFile();

  //   process.exit(0);
};
main();

