const Mysql = require('mysql2/promise');
const shell = require('shelljs');
const fs = require('fs');
const { promises: Fs } = require('fs');
const recursive = require('recursive-readdir');
const config = require('config');

const shellexec = async (command) => {
  // console.log(command);
  return new Promise((resolve, reject) => {
    shell.exec(command, { async: true }, function (code, stdout, stderr) {
      if (stderr && code !== 0) {
        console.log(stderr);
        console.log(stdout);
        resolve({ success: false, code: code, result: stderr });
      }

      if (code === 2) {
        console.log(stderr);
        console.log(stdout);
        resolve({ success: false, code: code, result: stdout });
      }
      resolve({ success: true, code: code, result: stdout });
    });
  });
};

const exists = async (path) => {
  try {
    await Fs.access(path);
    return true;
  } catch {
    return false;
  }
};

const moveback = async () => {
  try {
    const urlRegex = /(https?:\/\/[^ ]*\.apk(s|m)?">)/;
    const regexTest = /\.apk(s|m)?$/;
    const dir = config.get('dir');
    const archiveDir = config.get('archiveDir');
    const mysql = await Mysql.createConnection(config.get('maindb'));
    const [totalRecord] = await mysql.query(
      `select \`post_content\` from wp_posts where \`post_content\`  like '%dl1.vipapk.org%$%%.apk%' escape '$' or \`post_content\` like '%dl.apkcap.com%$%%.apk%' escape '$'`
    );
    for (let record of totalRecord) {
      const checkFileFull = decodeURIComponent(
        record.post_content
          .match(urlRegex)[1]
          .replace('">', '')
          .replace('https://', '')
      );
      const checkFileName = checkFileFull.substr(
        checkFileFull.lastIndexOf('/') + 1
      );
      const originDir = checkFileFull.replace(checkFileName, '');
	console.log(`checking file ${dir}/${originDir}/'${checkFileName}'`)
      const checkFileExist = await exists(
        `${dir}/${originDir}/${checkFileName}`
      );
      if (!checkFileExist) {
        console.log(`restoring file ${dir}/${originDir}/'${checkFileName}'`);
        const moveBackResult = await shellexec(
          `mv ${archiveDir}/'${checkFileName}' ${dir}/${originDir}/`
        );
        console.log(moveBackResult);
      }
    }
    console.log('done');
    process.exit(0);
  } catch (err) {
    console.log(err);
  }
};

const main = async () => {
  await moveback();

  //   process.exit(0);
};
main();

